# Record TCefFrameHandler

Description
Hierarchy
Fields
Methods
Properties

## Unit

uCEFTypes

## Declaration

`type TCefFrameHandler = record`

## Description

Implement this STRUCTURE to handle events related to ICefFrame life span. The order of callbacks is:

(1) During initial ICefBrowserHost creation and navigation of the main frame: - ICefFrameHandler.OnFrameCreated => The initial main frame object has been created. Any commands will be queued until the frame is attached. - ICefFrameHandler.OnMainFrameChanged => The initial main frame object has been assigned to the browser. - ICefLifeSpanHandler.OnAfterCreated => The browser is now valid and can be used. - ICefFrameHandler.OnFrameAttached => The initial main frame object is now connected to its peer in the renderer process. Commands can be routed.

(2) During further ICefBrowserHost navigation/loading of the main frame and/or sub-frames: - ICefFrameHandler.OnFrameCreated => A new main frame or sub-frame object has been created. Any commands will be queued until the frame is attached. - ICefFrameHandler.OnFrameAttached => A new main frame or sub-frame object is now connected to its peer in the renderer process. Commands can be routed. - ICefFrameHandler.OnFrameDetached => An existing main frame or sub- frame object has lost its connection to the renderer process. If multiple objects are detached at the same time then notifications will be sent for any sub-frame objects before the main frame object. Commands can no longer be routed and will be discarded. - ICefFrameHandler.OnMainFrameChanged => A new main frame object has been assigned to the browser. This will only occur with cross-origin navigation or re-navigation after renderer process termination (due to crashes, etc).

(3) During final ICefBrowserHost destruction of the main frame: - ICefFrameHandler.OnFrameDetached => Any sub-frame objects have lost their connection to the renderer process. Commands can no longer be routed and will be discarded. - ICefLifeSpanHandler.OnBeforeClose => The browser has been destroyed. - ICefFrameHandler.OnFrameDetached => The main frame object have lost its connection to the renderer process. Notifications will be sent for any sub-frame objects before the main frame object. Commands can no longer be routed and will be discarded. - ICefFrameHandler.OnMainFrameChanged => The final main frame object has been removed from the browser.

Cross-origin navigation and/or loading receives special handling.

When the main frame navigates to a different origin the OnMainFrameChanged callback (2) will be executed with the old and new main frame objects.

When a new sub-frame is loaded in, or an existing sub-frame is navigated to, a different origin from the parent frame, a temporary sub-frame object will first be created in the parent's renderer process. That temporary sub-frame will then be discarded after the real cross-origin sub-frame is created in the new/target renderer process. The client will receive cross-origin navigation callbacks (2) for the transition from the temporary sub-frame to the real sub-frame. The temporary sub-frame will not recieve or execute commands during this transitional period (any sent commands will be discarded).

When a new popup browser is created in a different origin from the parent browser, a temporary main frame object for the popup will first be created in the parent's renderer process. That temporary main frame will then be discarded after the real cross-origin main frame is created in the new/target renderer process. The client will recieve creation and initial navigation callbacks (1) for the temporary main frame, followed by cross- origin navigation callbacks (2) for the transition from the temporary main frame to the real main frame. The temporary main frame may receive and execute commands during this transitional period (any sent commands may be executed, but the behavior is potentially undesirable since they execute in the parent browser's renderer process and not the new/target renderer process).

Callbacks will not be executed for placeholders that may be created during pre-commit navigation for sub-frames that do not yet exist in the renderer process. Placeholders will have ICefFrame.GetIdentifier() == -4.

The functions of this interface will be called on the UI thread unless otherwise indicated.

NOTE: This struct is allocated client-side.

Implemented by ICefFrameHandler.

<see href="https://bitbucket.org/chromiumembedded/cef/src/master/include/capi/cef_frame_handler_capi.h">CEF source file: /include/capi/cef_frame_handler_capi.h (cef_frame_handler_t))

## Overview

### Fields

| `base: TCefBaseRefCounted;`
| `on_frame_created: procedure(self: PCefFrameHandler; browser: PCefBrowser; frame: PCefFrame); stdcall;`
| `on_frame_destroyed: procedure(self: PCefFrameHandler; browser: PCefBrowser; frame: PCefFrame); stdcall;`
| `on_frame_attached: procedure(self: PCefFrameHandler; browser: PCefBrowser; frame: PCefFrame; reattached: integer); stdcall;`
| `on_frame_detached: procedure(self: PCefFrameHandler; browser: PCefBrowser; frame: PCefFrame); stdcall;`
| `on_main_frame_changed: procedure(self: PCefFrameHandler; browser: PCefBrowser; old_frame, new_frame: PCefFrame); stdcall;`

## Description

### Fields

| `base: TCefBaseRefCounted;`
This item has no description.

| `on_frame_created: procedure(self: PCefFrameHandler; browser: PCefBrowser; frame: PCefFrame); stdcall;`
This item has no description.

| `on_frame_destroyed: procedure(self: PCefFrameHandler; browser: PCefBrowser; frame: PCefFrame); stdcall;`
This item has no description.

| `on_frame_attached: procedure(self: PCefFrameHandler; browser: PCefBrowser; frame: PCefFrame; reattached: integer); stdcall;`
This item has no description.

| `on_frame_detached: procedure(self: PCefFrameHandler; browser: PCefBrowser; frame: PCefFrame); stdcall;`
This item has no description.

| `on_main_frame_changed: procedure(self: PCefFrameHandler; browser: PCefBrowser; old_frame, new_frame: PCefFrame); stdcall;`
This item has no description.

Generated by PasDoc 0.16.0-snapshot.